local version = "1.0.4"
--/run print(GetBuildInfo());
--/fstack

local focus = CreateFrame("Button", "focus", UIParent, "SecureUnitButtonTemplate")
-- Give it click actions:
focus:RegisterForClicks("AnyUp")
focus:SetAttribute("*type1", "macro") -- left click causes macro
focus:SetAttribute("macrotext1", "/run checkIfHasNoFocusAndDisplayError()")

focus:SetMovable(true)
focus:EnableMouse(true)
focus:RegisterForDrag("LeftButton")
focus:SetScript("OnDragStart", focus.StartMoving)
focus:SetScript("OnDragStop", focus.StopMovingOrSizing)

focus:SetFrameStrata("LOW")
focus:SetSize(200,90)
focus:SetText("set as target")
focus:SetPoint("LEFT",0,0)
focus:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8" })
focus:SetBackdropColor(0.9, 0.9, 0.9, 0.0)

-----------------------

local focusTargetPortrait = focus:CreateTexture(nil, "BACKGROUND")
focusTargetPortrait:SetSize(60,60)
focusTargetPortrait:SetPoint("TOPRIGHT",-13,-14)

-----------------------

local focusBG = focus:CreateTexture(nil, "BACKGROUND2")
focusBG:SetSize(200,90)
focusBG:SetPoint("TOPLEFT",0,0);
focusBG:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame");
focusBG:SetTexCoord(0.1, 0.87, 0, 0.7);

-----------------------

local focusTargetNameBgUnder = CreateFrame("Frame",nil,focus)
focusTargetNameBgUnder:SetFrameLevel(0)
focusTargetNameBgUnder:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", edgeSize=32 })
focusTargetNameBgUnder:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

local focusTargetNameBg = CreateFrame("Frame",nil,focus)
focusTargetNameBg:SetFrameLevel(1)
-- focusTargetNameBg:SetBackdrop({
    -- bgFile="Interface/Tooltips/UI-Tooltip-Background", 
    --edgeFile="Interface/Tooltips/UI-Tooltip-Border",
    -- tile=true,tileSize=16,edgeSize=16, 
    -- insets={left=0,right=0,top=0,bottom=0}
-- });
-- focusTargetNameBg:SetBackdropBorderColor(TOOLTIP_DEFAULT_COLOR.r,TOOLTIP_DEFAULT_COLOR.g,TOOLTIP_DEFAULT_COLOR.b);
-- focusTargetNameBg:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r,TOOLTIP_DEFAULT_BACKGROUND_COLOR.g,TOOLTIP_DEFAULT_BACKGROUND_COLOR.b);
focusTargetNameBg:SetBackdrop({ bgFile = "Interface\\CharacterFrame\\BarFill", edgeSize=32 })
focusTargetNameBg:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

-- focusTargetNameBg:SetBackdrop({ bgFile = "Interface\\CharacterFrame\\BarFill", edgeSize=16 })
-- focusTargetNameBg:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

-- focusTargetCastbarBg:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", insets = { left = 4, right = 4, top = 4, bottom = 4 }, edgeSize=16 })
-- focusTargetCastbarBg:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

local focusTargetNameFrame = CreateFrame("Frame",nil,focus)

-- focusTargetNameFrame:SetBackdrop({ bgFile = "Interface\\CharacterFrame\\BarFill", insets = { left = 0, right = 1, top = 2, bottom = 2 }, edgeSize=16 })
-- focusTargetNameFrame:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

local focusTargetName = focusTargetNameFrame:CreateFontString(nil,"OVERLAY",f,"TextStatusBarText")
focusTargetName:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
focusTargetName:SetTextColor(1, 0.8, 0.8)
focusTargetName:SetText("Name")

focusTargetNameBgUnder:SetSize(119,20)
focusTargetNameBgUnder:SetPoint("TOPLEFT",5,-22);
focusTargetNameBg:SetSize(119,20)
focusTargetNameBg:SetPoint("TOPLEFT",5,-22);
focusTargetNameFrame:SetSize(119,20)
focusTargetNameFrame:SetPoint("TOPLEFT",5,-22);
focusTargetName:SetSize(100,20)
focusTargetName:SetPoint("CENTER",0,0)

-----------------------

local focusTargetLevelFrame = CreateFrame("Frame",nil,focus)

local focusTargetLevel = focusTargetLevelFrame:CreateFontString(nil,"OVERLAY",f,"TextStatusBarText")
focusTargetLevel:SetFont("Fonts\\FRIZQT__.TTF", 11, "THINOUTLINE")
focusTargetLevel:SetTextColor(1, 0.8, 0)
focusTargetLevel:SetText("??")

focusTargetLevelFrame:SetSize(20,20)
focusTargetLevelFrame:SetPoint("BOTTOMRIGHT",-9.5,13.3);
focusTargetLevel:SetSize(20,20)
focusTargetLevel:SetPoint("CENTER",0,0)

-----------------------

local focusTargetHealthBgUnder = CreateFrame("Frame",nil,focus)
focusTargetHealthBgUnder:SetFrameLevel(0)
focusTargetHealthBgUnder:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", insets = { left = 0, right = 0, top = 0, bottom = 2 }, edgeSize=32 })
focusTargetHealthBgUnder:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

local focusTargetHealthBg = CreateFrame("Frame",nil,focus)
focusTargetHealthBg:SetFrameLevel(1)
-- focusTargetHealthBg:SetBackdrop({
    -- bgFile="Interface/Tooltips/UI-Tooltip-Background", 
    edgeFile="Interface/Tooltips/UI-Tooltip-Border",
    -- tile=true,tileSize=16,edgeSize=16, 
    -- insets={left=0,right=0,top=0,bottom=0}
-- });
-- focusTargetHealthBg:SetBackdropBorderColor(TOOLTIP_DEFAULT_COLOR.r,TOOLTIP_DEFAULT_COLOR.g,TOOLTIP_DEFAULT_COLOR.b);

-- focusTargetHealthBg:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", edgeSize=16 })
-- focusTargetHealthBg:SetBackdropColor(0.0, 1.0, 0.0, 1.0)

focusTargetHealthBg:SetBackdrop({ bgFile = "Interface\\CharacterFrame\\BarFill", insets = { left = 0, right = 0, top = 0, bottom = 2 }, edgeSize=32 })
focusTargetHealthBg:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

-- focusTargetHealthBg:SetBackdrop({ bgFile = "Interface\\CharacterFrame\\BarFill", edgeSize=16 })
-- focusTargetHealthBg:SetBackdropColor(0.0, 1.0, 0.0, 1.0)

-- focusTargetHealthBg:SetTexture("Interface\\CharacterFrame\\UI-StateIco");
-- focusTargetHealthBg:SetTexCoord(0.1, 0.87, 0, 0.7);

local focusTargetHealthFrame = CreateFrame("Frame",nil,focus)

-- focusTargetHealthFrame:SetBackdrop({ bgFile = "Interface\\CharacterFrame\\BarFill", insets = { left = 0, right = 0, top = 2, bottom = 1 }, edgeSize=16 })
-- focusTargetHealthFrame:SetBackdropColor(0.0, 1.0, 0.0, 1.0)

local focusTargetHealth = focusTargetHealthFrame:CreateFontString(nil,"OVERLAY",f,"TextStatusBarText")
focusTargetHealth:SetFont("Fonts\\ARIALN.TTF", 13, "THINOUTLINE")
focusTargetHealth:SetTextColor(1, 1, 1)
focusTargetHealth:SetText("HP: ??/??")


local focusTargetHealthMaxW = 119
local focusTargetHealthMaxH = 15
focusTargetHealthBgUnder:SetSize(focusTargetHealthMaxW,focusTargetHealthMaxH)
focusTargetHealthBgUnder:SetPoint("TOPLEFT",5,-40);
focusTargetHealthBg:SetSize(focusTargetHealthMaxW,focusTargetHealthMaxH)
focusTargetHealthBg:SetPoint("TOPLEFT",5,-40);
focusTargetHealthFrame:SetSize(focusTargetHealthMaxW,focusTargetHealthMaxH)
focusTargetHealthFrame:SetPoint("TOPLEFT",5,-40);
focusTargetHealth:SetSize(118,focusTargetHealthMaxH)
focusTargetHealth:SetPoint("CENTER",0,0)

-----------------------

local focusTargetPowerBgUnder = CreateFrame("Frame",nil,focus)
focusTargetPowerBgUnder:SetFrameLevel(0)
focusTargetPowerBgUnder:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", insets = { left = 0, right = 0, top = 0, bottom = 2 }, edgeSize=32 })
focusTargetPowerBgUnder:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

local focusTargetPowerBg = CreateFrame("Frame",nil,focus)
focusTargetPowerBg:SetFrameLevel(1)
-- focusTargetPowerBg:SetBackdrop({
    -- bgFile="Interface/Tooltips/UI-Tooltip-Background", 
    edgeFile="Interface/Tooltips/UI-Tooltip-Border",
    -- tile=true,tileSize=16,edgeSize=16, 
    -- insets={left=0,right=0,top=0,bottom=0}
-- });
-- focusTargetPowerBg:SetBackdropBorderColor(TOOLTIP_DEFAULT_COLOR.r,TOOLTIP_DEFAULT_COLOR.g,TOOLTIP_DEFAULT_COLOR.b);

focusTargetPowerBg:SetBackdrop({ bgFile = "Interface\\CharacterFrame\\BarFill", insets = { left = 0, right = 0, top = 0, bottom = 2 }, edgeSize=32 })
focusTargetPowerBg:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

-- focusTargetPowerBg:SetBackdrop({ bgFile = "Interface\\CharacterFrame\\BarFill", edgeSize=16 })
-- focusTargetPowerBg:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

local focusTargetPowerFrame = CreateFrame("Frame",nil,focus)

-- focusTargetPowerFrame:SetBackdrop({ bgFile = "Interface\\CharacterFrame\\BarFill", insets = { left = 0, right = 0, top = 2, bottom = 1 }, edgeSize=16 })
-- focusTargetPowerFrame:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

local focusTargetPower = focusTargetPowerFrame:CreateFontString(nil,"OVERLAY",f,"TextStatusBarText")
focusTargetPower:SetFont("Fonts\\ARIALN.TTF", 13, "THINOUTLINE")
focusTargetPower:SetTextColor(1, 1, 1)
focusTargetPower:SetText("PWR: ??/??")

local focusTargetPowerMaxW = 119
local focusTargetPowerMaxH = 15
focusTargetPowerBgUnder:SetSize(focusTargetPowerMaxW,focusTargetPowerMaxH)
focusTargetPowerBgUnder:SetPoint("TOPLEFT",5,-51);
focusTargetPowerBg:SetSize(focusTargetPowerMaxW,focusTargetPowerMaxH)
focusTargetPowerBg:SetPoint("TOPLEFT",5,-51);
focusTargetPowerFrame:SetSize(focusTargetPowerMaxW,focusTargetPowerMaxH)
focusTargetPowerFrame:SetPoint("TOPLEFT",5,-51)
focusTargetPower:SetSize(118,focusTargetPowerMaxH)
focusTargetPower:SetPoint("CENTER",0,0)

-----------------------

local focusTargetCastBarBg = CreateFrame("Frame",nil,focus)
-- focusTargetCastbarBg:SetFrameLevel(1)
-- focusTargetCastbarBg:SetBackdrop({ bgFile = "Interface\\CharacterFrame\\BarFill", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", insets = { left = 4, right = 4, top = 4, bottom = 4 }, edgeSize=16 })

focusTargetCastBarBg:SetFrameLevel(0)
-- focusTargetCastbarBg:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", insets = { left = 4, right = 4, top = 4, bottom = 4 }, edgeSize=16 })
-- focusTargetCastbarBg:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

focusTargetCastBarBg:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", insets = { left = 4, right = 4, top = 4, bottom = 4 }, edgeSize=16 })
focusTargetCastBarBg:SetBackdropColor(0.0, 0.0, 0.0, 0.4)

local focusTargetCastBarProgressUnder = CreateFrame("Frame",nil,focus)
focusTargetCastBarProgressUnder:SetFrameLevel(0)
focusTargetCastBarProgressUnder:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", insets = { left = 4, right = 4, top = 4, bottom = 4 }, edgeSize=16 })
focusTargetCastBarProgressUnder:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

local focusTargetCastBarProgress = CreateFrame("Frame",nil,focus)
focusTargetCastBarProgress:SetFrameLevel(1)
focusTargetCastBarProgress:SetBackdrop({ bgFile = "Interface\\CharacterFrame\\BarFill", insets = { left = 4, right = 4, top = 4, bottom = 4 }, edgeSize=16 })
focusTargetCastBarProgress:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

local focusTargetCastBarFrame = CreateFrame("Frame",nil,focus)
-- focusTargetCastbarBg:SetFrameLevel(0)
-- focusTargetCastbarBg:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", insets = { left = 4, right = 4, top = 4, bottom = 4 }, edgeSize=16 })

-- focusTargetCastBarFrame:SetFrameLevel(1)
focusTargetCastBarFrame:SetBackdrop({edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", insets = { left = 4, right = 4, top = 4, bottom = 4 }, edgeSize=16 })
focusTargetCastBarFrame:SetBackdropColor(0.0, 0.0, 1.0, 1.0)

local focusTargetCastBarText = focusTargetCastBarFrame:CreateFontString(nil,"OVERLAY",f,"TextStatusBarText")
focusTargetCastBarText:SetFont("Fonts\\ARIALN.TTF", 13, "THINOUTLINE")
focusTargetCastBarText:SetTextColor(1, 1, 1)
focusTargetCastBarText:SetText("Spell")

focusTargetCastBarBg:SetSize(179,20)
focusTargetCastBarBg:SetPoint("TOPLEFT",5,-80);
focusTargetCastBarProgressUnder:SetSize(179,20)
focusTargetCastBarProgressUnder:SetPoint("TOPLEFT",5,-80);
focusTargetCastBarProgress:SetSize(179,20)
focusTargetCastBarProgress:SetPoint("TOPLEFT",5,-80);
focusTargetCastBarFrame:SetSize(179,20)
focusTargetCastBarFrame:SetPoint("TOPLEFT",5,-80);
focusTargetCastBarText:SetSize(179,20)
focusTargetCastBarText:SetPoint("LEFT",0,0)

focusTargetCastBarBg:Hide()
focusTargetCastBarFrame:Hide()

-----------------------

focus:SetFrameLevel(120)
--focus:Hide()

-----------------------

-- local focusButton = CreateFrame("Button","focusButton",TargetFrameTextureFrame,"UIPanelButtonTemplate") --frameType, frameName, frameParent, frameTemplate
local focusButton = CreateFrame("Button","focusButton",TargetFrameTextureFrame,"UIPanelButtonTemplate")
focusButton:SetSize(125,20)
focusButton:SetText("set focus")
focusButton:SetPoint("TOPLEFT",2,-2)
focusButton:SetScript("OnClick", function(self, arg1)
    setFocusFromCurrentTarget()
end)

function cfHookBtnToZperlTargetFrame()
	local focusButton2 = CreateFrame("Button","focusButton2",XPerl_TargetnameFrame,"UIPanelButtonTemplate")
	focusButton2:SetSize(157,20)
	focusButton2:SetText("set focus")
	focusButton2:SetPoint("TOPLEFT",2,20)
	focusButton2:SetScript("OnClick", function(self, arg1)
		setFocusFromCurrentTarget()
	end)
end


-----------------------

local clearFocusButton = CreateFrame("Button","clearFocusButton",focus,"UIPanelButtonTemplate") --frameType, frameName, frameParent, frameTemplate
clearFocusButton:SetSize(105,20)
clearFocusButton:SetText("clear focus")
clearFocusButton:SetPoint("TOPLEFT",1,-2)
clearFocusButton:SetScript("OnClick", function(self, arg1)
    --setFocusFromCurrentTarget()
	clearFocus()
end)

local focusFrameLocked = false
local focusLockButtonLockText = "|TInterface\\LFGFrame\\UI-LFG-ICON-LOCK:16:16:2:-2:16:16:0:16:0:16:255:238:170|t"
local focusLockButtonUnlockText = "|TInterface\\LFGFrame\\UI-LFG-ICON-LOCK:16:16:2:-2:16:16:0:16:0:16:255:000:000|t"

local focusLockButton = CreateFrame("Button","focusLockButton",focus,"UIPanelButtonTemplate") --frameType, frameName, frameParent, frameTemplate
focusLockButton:SetSize(20,20)
focusLockButton:SetText(focusLockButtonLockText)
focusLockButton:SetPoint("TOPLEFT",105,-2)
focusLockButton:SetScript("OnClick", function(self, arg1)
    --setFocusFromCurrentTarget()
	-- clearFocus()
	-- !clearFocusButton:isMovable()
	focusFrameLocked = not focusFrameLocked
	setFocusLockButtonLocked()	
end)

function setFocusLockButtonLocked()
	if not focusFrameLocked then
		focusFrameLocked = false
		focusLockButton:SetText(focusLockButtonLockText)
		ClassicFocusSettings.focusFrameLocked = false
	else
		focusFrameLocked = true
		focusLockButton:SetText(focusLockButtonUnlockText)
		ClassicFocusSettings.focusFrameLocked = true
	end
end

focus:RegisterForDrag("LeftButton")
focus:SetScript("OnDragStart", function(self)
  if not focusFrameLocked then
    self:StartMoving()
  end
end)


-----------------------

-- focus:HookScript('OnClick', function(self, button, down)
   --if button == 'LeftButton' and not IsModifierKeyDown() then
   --   DoEmote('point')
   --end
   --DoEmote('point')
   --if button == 'LeftButton' and not down then
	   --if currentFocusTargetName ~= UnitName("target") then
		--	NotWhileDeadError()
		--	NotWhileDeadError()
		--	NotWhileDeadError()
		--	print("|cffFF0000--ClassicFocus: UNABLE TO SELECT YOUR FOCUS TARGET--");
	   --end
   --end
-- end)

function displayCantSelectFocusTargetError()
	NotWhileDeadError()
	NotWhileDeadError()
	NotWhileDeadError()
	print("|cffFF0000--ClassicFocus: UNABLE TO SELECT YOUR FOCUS TARGET--");
end

function displayYouHaveNoFocusTargetError()
	NotWhileDeadError()
	NotWhileDeadError()
	NotWhileDeadError()
	print("|cffFF0000--ClassicFocus: YOU HAVE NO FOCUS TARGET--");
end

function displayYouHaveNoTargetError()
	NotWhileDeadError()
	NotWhileDeadError()
	NotWhileDeadError()
	print("|cffFF0000--ClassicFocus: YOU HAVE NO TARGET TO SET FOCUS TO--");
end

function checkIfHasNoFocusAndDisplayError()
	if currentFocusTargetName == nil then
		displayYouHaveNoFocusTargetError()
	end
end

currentFocusTargetName = nil

function clearFocus()
	focusTargetHealthBgUnder:SetSize(focusTargetHealthMaxW,15)
    focusTargetHealthBg:SetSize(focusTargetHealthMaxW,15)
	focusTargetPowerBgUnder:SetSize(focusTargetPowerMaxW,15)
    focusTargetPowerBg:SetSize(focusTargetPowerMaxW,15)
	currentFocusTargetName = nil
	-- focus:SetAttribute("macrotext1", "/cleartarget\n/target " .. "-" .. "\n/stopmacro [exists]\n/run displayYouHaveNoFocusTargetError()") -- text for macro on left clickclick
	focus:SetAttribute("macrotext1", "/target " .. "-" .. "\n/stopmacro [exists]\n/run displayYouHaveNoFocusTargetError()") -- text for macro on left
	focus:Hide()
	hideCastBar()
end

function setFocusFromCurrentTarget()
	if UnitName("target") ~= nil then
		currentFocusTargetName = UnitName("target")
		-- print(UnitGUID("target"))
		-- focus:SetAttribute("macrotext1", "/cleartarget\n/target " .. currentFocusTargetName .. "\n/stopmacro [exists]\n/run displayCantSelectFocusTargetError()") -- text for macro on left clickclick
		focus:SetAttribute("macrotext1", "/target " .. currentFocusTargetName .. "\n/stopmacro [exists]\n/run displayCantSelectFocusTargetError()")
		if currentFocusTargetName ~= nil then
			updateFocusFromCurrentTarget()
			focus:Show()
			checkFocusTarget()
		end
	else
		displayYouHaveNoTargetError()
	end
end

function updateFocusFromCurrentTarget()
	--focusTargetName:SetFormattedText("%s (%s)", UnitName("target"))
	focusTargetName:SetText(UnitName("target"))
	if UnitLevel("target") > 0 then
		focusTargetLevel:SetText(UnitLevel("target"))
	else
		focusTargetLevel:SetText("??")
	end
	if not UnitExists("target") then
		focusTargetHealth:SetText("n/e")
		focusTargetPower:SetText("n/e")
	elseif UnitIsDead("target") then
		focusTargetHealth:SetText("dead")
		focusTargetPower:SetText("dead")
		SetPortraitTexture(focusTargetPortrait, "target")
		focusTargetHealthBgUnder:SetSize(0,focusTargetHealthMaxH)	
		focusTargetHealthBg:SetSize(0,focusTargetHealthMaxH)
		focusTargetPowerBgUnder:SetSize(0,focusTargetPowerMaxH)
		focusTargetPowerBg:SetSize(0,focusTargetPowerMaxH)
	else
		SetPortraitTexture(focusTargetPortrait, "target")
		if UnitHealthMax("target") == 100 then
			focusTargetHealth:SetFormattedText("%d/%d (%%)", UnitHealth("target"), UnitHealthMax("target"))
		else 
			focusTargetHealth:SetFormattedText("%d/%d", UnitHealth("target"), UnitHealthMax("target"))
		end			
		focusTargetPower:SetFormattedText("%d/%d", UnitPower("target"), UnitPowerMax("target"))
		
		if UnitHealth("target") == 0 or UnitHealthMax("target") == 0 then
			focusTargetHealthBgUnder:SetSize(1,focusTargetHealthMaxH)	
			focusTargetHealthBg:SetSize(1,focusTargetHealthMaxH)	
		else
			focusTargetHealthBgUnder:SetSize(focusTargetHealthMaxW*(UnitHealth("target")/UnitHealthMax("target")),focusTargetHealthMaxH)
			focusTargetHealthBg:SetSize(focusTargetHealthMaxW*(UnitHealth("target")/UnitHealthMax("target")),focusTargetHealthMaxH)	
		end
		if UnitPower("target") == 0 or UnitPowerMax("target") == 0 then
			focusTargetPowerBgUnder:SetSize(1,focusTargetPowerMaxH)
			focusTargetPowerBg:SetSize(1,focusTargetPowerMaxH)
		else
			focusTargetPowerBgUnder:SetSize(focusTargetPowerMaxW*(UnitPower("target")/UnitPowerMax("target")),focusTargetPowerMaxH)
			focusTargetPowerBg:SetSize(focusTargetPowerMaxW*(UnitPower("target")/UnitPowerMax("target")),focusTargetPowerMaxH)
		end
	end
end

function loadDefaultSettings() 
	ClassicFocusSettings = {
		  focusFrameLocked = false
	  }
end

function initSettings()
	if ClassicFocusSettings == nil then
		loadDefaultSettings()
		print("ClassicFocus: unable to load saved data, backing up to defaults")
	end	
	focusFrameLocked = ClassicFocusSettings.focusFrameLocked
	setFocusLockButtonLocked()	
end

local castedSpellName = "???"
local castedSpellTime = 1
local castedSpellTimeLeft = 1

function dispatchEventsHere(self, event, arg1, arg2, arg3, ...)
	if event == "ADDON_LOADED" and arg1 == "ClassicFocus" then
		print("ClassicFocus: Addon is loaded. Version: "..version)
		initSettings()
	end
	if event == "ADDON_LOADED" and arg1 == "ZPerl_Target" then
	print("ClassicFocus: ZPerl_Target is loaded. Hooking up!")
		cfHookBtnToZperlTargetFrame()
	end
	if event == "PLAYER_TARGET_CHANGED" then
		--nothing
		--if UnitName("target") ~= nil then
		--	focusTargetName:SetFormattedText("arg1: "..UnitName("target"))
		--elseif currentFocusTargetName ~= nil then
		--	--focus:Click()
		--end
	end
	if event == "UNIT_SPELLCAST_START" then
		-- print("ClassicFocus: UNIT_SPELLCAST_START: "..arg1..","..arg2..","..arg3)
		-- local spell = UnitCastingInfo("target")
		if arg1 == "target" then
			local name, rank, icon, castTime = GetSpellInfo(arg3)
			-- print("Targed is casting: spell name: "..name..", castTime: "..castTime..", icon:"..icon)
			castedSpellName = "|T"..icon..":0|t "..name
			-- focusTargetCastBarText:SetText("|T"..icon..":0|t "..name)
			castedSpellTime = castTime
			castedSpellTimeLeft = castTime
			showCastBar()
		end
		-- if spell then 
			-- local finish = endTime/1000 - GetTime()
			-- ChatFrame1:AddMessage(spell .. ' will be finished casting in ' .. finish .. ' seconds.')
		-- end
	end
	if event == "UNIT_SPELLCAST_STOP" then
		hideCastBar()
	end
	--if event == "OnKeyDown" then
	--	focusTargetName:SetFormattedText("Focused: %s", UnitName("target"))
	--end
	checkFocusTarget()
end

function hideCastBar()
	focusTargetCastBarBg:Hide()
	focusTargetCastBarProgress:Hide()
	focusTargetCastBarProgressUnder:Hide()
	focusTargetCastBarFrame:Hide()
end

function showCastBar()
	focusTargetCastBarBg:Show()
	focusTargetCastBarProgress:Show()
	focusTargetCastBarProgressUnder:Show()
	focusTargetCastBarFrame:Show()
end

function checkFocusTarget()
	local backDropAlpha = 1.0
	if currentFocusTargetName ~= nil and currentFocusTargetName == UnitName("target") then
		updateFocusFromCurrentTarget()
		focusTargetHealthBgUnder:SetBackdropColor(0.0, 1.0, 0.0, backDropAlpha)
		focusTargetHealthBg:SetBackdropColor(0.0, 1.0, 0.0, backDropAlpha)
		focusTargetPowerBgUnder:SetBackdropColor(0.0, 0.0, 1.0, backDropAlpha)
		focusTargetPowerBg:SetBackdropColor(0.0, 0.0, 1.0, backDropAlpha)
		
		if UnitIsPlayer("target") then
			if UnitIsEnemy("target", "player") then
				focusTargetNameBgUnder:SetBackdropColor(1.0, 0.0, 0.0, backDropAlpha)
				focusTargetNameBg:SetBackdropColor(1.0, 0.0, 0.0, backDropAlpha)
			elseif UnitIsPVP("target") then
				focusTargetNameBgUnder:SetBackdropColor(0.0, 1.0, 0.0, backDropAlpha)
				focusTargetNameBg:SetBackdropColor(0.0, 1.0, 0.0, backDropAlpha)
			else
				focusTargetNameBgUnder:SetBackdropColor(0.0, 0.0, 1.0, backDropAlpha)
				focusTargetNameBg:SetBackdropColor(0.0, 0.0, 1.0, backDropAlpha)
			end
		else
			if UnitIsEnemy("target", "player") then
				focusTargetNameBgUnder:SetBackdropColor(1.0, 0.0, 0.0, backDropAlpha)
				focusTargetNameBg:SetBackdropColor(1.0, 0.0, 0.0, backDropAlpha)
			elseif UnitReaction("target", "player") == 4 then
				focusTargetNameBgUnder:SetBackdropColor(1.0, 1.0, 0.0, backDropAlpha)
				focusTargetNameBg:SetBackdropColor(1.0, 1.0, 0.0, backDropAlpha)
			elseif UnitReaction("target", "player") < 4 then
				focusTargetNameBgUnder:SetBackdropColor(1.0, 0.0, 0.0, backDropAlpha)
				focusTargetNameBg:SetBackdropColor(1.0, 0.0, 0.0, backDropAlpha)
			else
				focusTargetNameBgUnder:SetBackdropColor(0.0, 1.0, 0.0, backDropAlpha)
				focusTargetNameBg:SetBackdropColor(0.0, 1.0, 0.0, backDropAlpha)
			end
		end
		
	else
		hideCastBar()
		--focusTargetNameBg:SetBackdropColor(0.0, 0.0, 0.6, 1.0)
		focusTargetHealthBgUnder:SetBackdropColor(0.8, 0.8, 0.8, backDropAlpha)
		focusTargetHealthBg:SetBackdropColor(0.8, 0.8, 0.8, backDropAlpha)
		focusTargetPowerBgUnder:SetBackdropColor(0.4, 0.4, 0.4, backDropAlpha)
		focusTargetPowerBg:SetBackdropColor(0.4, 0.4, 0.4, backDropAlpha)
	end
end

function classisFocusUpdate(self, elapsed) 
	local seconds = GetTime()
	local lastdigit = seconds % 10
	local firstdigit = math.floor(lastdigit)
	
	if focusTargetCastBarProgress:IsShown() then
		castedSpellTimeLeft = castedSpellTimeLeft - elapsed*1000
		
		focusTargetCastBarText:SetText(castedSpellName.." ("..string.format("%.1f", castedSpellTimeLeft/1000).."s)")
		
		local newCastProgressW = 179*(castedSpellTimeLeft/castedSpellTime)
		if newCastProgressW > 10 then
			focusTargetCastBarProgressUnder:SetSize(newCastProgressW,20)
			focusTargetCastBarProgress:SetSize(newCastProgressW,20)
		else 
			focusTargetCastBarProgressUnder:SetSize(0,20)
			focusTargetCastBarProgress:SetSize(0,20)
		end
	else 
		focusTargetCastBarProgressUnder:SetSize(179,20)
		focusTargetCastBarProgress:SetSize(179,20)
	end 
end

--INIT

focus:SetScript("OnEvent", dispatchEventsHere)
focus:SetScript("OnUpdate", classisFocusUpdate)
--focus:SetScript("OnKeyDown", dispatchEventsHere)
focus:RegisterEvent("ADDON_LOADED")
focus:RegisterEvent("UNIT_HEALTH")
focus:RegisterEvent("PLAYER_TARGET_CHANGED")
focus:RegisterEvent("PLAYER_ENTERING_WORLD")
focus:RegisterEvent("UNIT_POWER_FREQUENT")
focus:RegisterEvent("UNIT_SPELLCAST_START")
focus:RegisterEvent("UNIT_SPELLCAST_STOP")

clearFocus()